import xarray as xr
import numpy as np



def if_then_else(condition, val_if_true, val_if_false):
    print('entered if_then_else')
    con_xr = type(condition) == xr.DataArray

    # short circuit if a scalar condition
    # made to avoid computation of other part 
    if not con_xr:
        return val_if_true() if condition else val_if_false()

    true_xr = type(val_if_true) == xr.DataArray
    false_xr = type(val_if_false) == xr.DataArray

    if true_xr and false_xr and con_xr:
        val_if_true, val_if_false, condition = xr.align(val_if_true, val_if_false, condition)
        return val_if_true.where(condition, val_if_false)
    elif not true_xr and false_xr and con_xr:
        val_if_false, condition = xr.align(val_if_false, condition)
        return val_if_false.where(np.logical_not(condition), val_if_true)
    elif true_xr and not false_xr and con_xr:
        val_if_true, condition = xr.align(val_if_true, condition)
        return val_if_true.where(condition, val_if_false)
    elif true_xr and false_xr:
        val_if_true, val_if_false = xr.align(val_if_true, val_if_false)
        return val_if_true.where(condition, val_if_false)
    elif not true_xr and false_xr:
        return val_if_false.where(not condition, val_if_true)
    elif true_xr and not false_xr:
        return val_if_true.where(condition, val_if_false)
    elif con_xr:
        return (condition*0 + val_if_true).where(condition, val_if_false)    
    else:
        return np.where(condition, val_if_true, val_if_false)


def func1():
	print('entered 1')
	return xr.DataArray(data=[1,2,3], dims=['a'], coords={'a':['u', 'v', 'w']})

def func2():
	print('entered 2')
	return xr.DataArray(data=[4,5,6], dims=['a'], coords={'a':['u', 'v', 'w']})	

time = 1

print(if_then_else(time < 2, func1, func2))